'-------------------------------------------------------------------------------
'UNO_spi2.BAS  SPI Master
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim B As Bit
Dim Dout As Word
Dim N As Byte
Dim I As Byte

Sck Alias Portb.5
Ddrb.5 = 1
Mosi Alias Portb.3
Ddrb.3 = 1
Cs Alias Portb.2
Ddrb.2 = 1

Cs = 1
Mosi = 0
Sck = 0


Config Adc = Single , Prescaler = 32 , Reference = Avcc     'Pre 8...32
Start Adc

Cls
Cursor Off

Waitms 200
Do
  Dout = Getadc(3)                                          'Pot
  Locate 1 , 1
  Lcd Dout
  Lcd "    "
  Cs = 0
  Waitms 20
  For N = 1 To 10
    Mosi = Dout.9
    Waitms 1
    Sck = 1
    Waitms 1
    Sck = 0
    Waitms 1
    Shift Dout , Left
  Next N
  Cs = 1
  Waitms 100
Loop

End