'-------------------------------------
'UNO_LCD1.BAS input/output PCA9555
'-------------------------------------
$regfile = "m328pdef.dat"
$crystal = 16000000
$baud = 9600

Dim N As Byte
Dim D As Byte

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Cls
Lcd "I2C-Bus"
Cursor Off

Config Scl = Portc.5
Config Sda = Portc.4
I2cinit

I2cstart
I2cwbyte 64                                                 'Gnublin port expander
I2cwbyte 6
I2cwbyte 0                                                  'Port 0 output
I2cwbyte 255                                                'Port 1 input
I2cstop

Do
  For N = 0 To 255
    I2cstart
    I2cwbyte 64                                             'write
    I2cwbyte 2
    I2cwbyte N
    I2cstop
    Print N;
    Print "  ";
    Locate 2 , 1
    Lcd N
    Lcd "  "

    I2cstart
    I2cwbyte 64                                             'write
    I2cwbyte 1
    I2cstart
    I2cwbyte 65                                             'read
    I2crbyte D , Nack
    I2cstop
    Print D
    Locate 2 , 5
    Lcd D
    Lcd "  "
    Waitms 100
  Next N
Loop

End
