'-------------------------------------------------------------------------------
'UNO_Timer4.BAS  Timer0-Interrupt, Seconds
'-------------------------------------------------------------------------------
'$regfile = "m328pdef.dat"                                   'ATmega328p
$regfile = "m168pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 8
$swstack = 4
$framesize = 4


Dim Ticks As Word
Dim Hi As Byte
Dim Lo As Byte


Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off

Lcd "Charleplex"


Config Timer0 = Timer , Prescale = 64
On Ovf0 Tim0_isr
Enable Timer0
Enable Interrupts
Start Timer0

Do
 Lo = Rnd(255)
 Waitms 1000

Loop

Tim0_isr:
  Ddrc = &B00000000
  Portc = &B00000000
  Ticks = Ticks + 1
  If Ticks = 1 And Lo.0 = 1 Then
    Ddrc = &B00000011
    Portc = &B00000001
  End If
  If Ticks = 2 And Lo.1 = 1 Then
    Ddrc = &B00000011
    Portc = &B00000010
  End If
  If Ticks = 3 And Lo.2 = 1 Then
    Ddrc = &B00000110
    Portc = &B00000010
  End If
  If Ticks = 4 And Lo.3 = 1 Then
    Ddrc = &B00000110
    Portc = &B00000100
  End If
  If Ticks = 5 And Lo.4 = 1 Then
    Ddrc = &B00000101
    Portc = &B00000001
  End If
  If Ticks = 6 And Lo.5 = 1 Then
    Ddrc = &B00000101
    Portc = &B00000100
  End If


  If Ticks = 9 Then Ticks = 0
 Return

End