'-------------------------------------------------------------------------------
'UNO_AM.BAS  B0 RF out open drain
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 32
$swstack = 32
$framesize = 64

Dim F As Word
Dim D As Word
Dim U As Word

Led1 Alias Portc.2
Led2 Alias Portb.2
S1 Alias Pinc.0
S2 Alias Pinc.1
Portc.0 = 1                                                 'Pullup
Portc.1 = 1
Config Led1 = Output
Config Led2 = Output

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off


Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

Do
  U = Getadc(3)
  D = U / 46
  D = D + 10
  F = 16000 / D
  Locate 1 , 1
  Lcd F
  Lcd " kHz " "
  Waitms 500
  If S1 = 0 Then
    Led2 = 1
    If D = 10 Then Goto D10
    If D = 11 Then Goto D11
    If D = 12 Then Goto D12
    If D = 13 Then Goto D13
    If D = 14 Then Goto D14
    If D = 15 Then Goto D15
    If D = 16 Then Goto D16
    If D = 17 Then Goto D17
    If D = 18 Then Goto D18
    If D = 19 Then Goto D19
    If D = 20 Then Goto D20
    If D = 21 Then Goto D21
    If D = 22 Then Goto D22
    If D = 23 Then Goto D23
    If D = 24 Then Goto D24
    If D = 25 Then Goto D25
    If D = 26 Then Goto D26
    If D = 27 Then Goto D27
    If D = 28 Then Goto D28
    If D = 29 Then Goto D29
    If D = 30 Then Goto D30
    If D = 31 Then Goto D31
    If D = 32 Then Goto D32
  End If
Loop



D32:
Do                                                          '32 500 kHz
  Ddrb.0 = 1                                                '+25
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop

D31:
Do                                                          '31 516 kHz
  Ddrb.0 = 1                                                '+24
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop

D30:
Do                                                          '30 533 kHz
  Ddrb.0 = 1                                                '+23
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop

D29:
Do                                                          '29 551 kHz
  Ddrb.0 = 1                                                '+22
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop


D28:
Do                                                          '28 571 kHz
  Ddrb.0 = 1                                                '+21
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop

D27:
Do                                                          '27 592 kHz
  Ddrb.0 = 1                                                '+20
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop

D26:
Do                                                          '26 615 kHz
  Ddrb.0 = 1                                                '+19
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop



D25:
Do                                                          '25 640 kHz
  Ddrb.0 = 1                                                '+18
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop


D24:
Do                                                          '24 666 kHz
  Ddrb.0 = 1                                                '+17
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop



D23:
Do                                                          '23 695 kHz
  Ddrb.0 = 1                                                '+16
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
  nop
Loop


D22:
Do                                                          '22 727 kHz
  Ddrb.0 = 1                                                '+15
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
Loop


D21:
Do                                                          '21 741 kHz
  Ddrb.0 = 1                                                '+14
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
  nop
Loop


D20:
Do                                                          '20 800 kHz
  Ddrb.0 = 1                                                '+13
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
Loop

D19:
Do                                                          '19 942 kHz
  Ddrb.0 = 1                                                '+12
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
  nop
Loop



D18:
Do                                                          '18 888 kHz
  Ddrb.0 = 1                                                '+11
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
Loop


D17:
Do                                                          '17 941 kHz
  Ddrb.0 = 1
  nop                                                       '+10
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
  nop
Loop



D16:
Do                                                          '16 1000 kHz
  Ddrb.0 = 1
  nop                                                       '+9
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
Loop

D15:
Do                                                          '15 1066 kHz
  Ddrb.0 = 1
  nop                                                       '+8
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
  nop
Loop


D14:
Do                                                          '14 1142 kHz
  Ddrb.0 = 1                                                '+7
  nop
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
Loop

D13:
Do                                                          '13, 1230 kHz
  Ddrb.0 = 1
  nop                                                       '+6
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
  nop
Loop

D12:
Do                                                          '12, 1333 kHz
  Ddrb.0 = 1                                                '+5
  nop
  nop
  nop
  nop
  Ddrb.0 = 0
  nop
Loop

D11:
Do                                                          '11, 1454 kHz
  Ddrb.0 = 1
  nop                                                       '+4 nop
  nop
  nop
  Ddrb.0 = 0
  nop
Loop

D10:
Do                                                          '10, 1,6 MHz
  Ddrb.0 = 1
  nop                                                       '+3 nop
  nop
  nop
  Ddrb.0 = 0
Loop