'-------------------------------------------------------------------------------
'UNO_LCD2.BAS  Voltage A0, A3
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim D As Word
Dim U As Single

Config Adc = Single , Prescaler = 64 , Reference = Avcc     '5 V

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Cls
Cursor Off
Do
  Locate 1 , 1
  Lcd "A0 "
  D = Getadc(1)                                             'A0
  U = D * 5.0
  U = U / 1023
  Lcd U
  Lcd "    "

  Locate 2 , 1                                              'Pot
  Lcd "A3 "
  D = Getadc(3)
  U = D * 5.0
  U = U / 1023
  Lcd U
  Lcd "    "
  Waitms 1000
Loop