'-------------------------------------------------------------------------------
'UNO_Timer2.BAS  Timer1,  0.5 us
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 16                                               '8
$swstack = 16                                               '4
$framesize = 16                                             '4

Dim D As Word


Config Timer1 = Timer , Prescale = 8                        'Clock 2 MHz
Config Timer2 = Pwm , Prescale = 256 , Compare A Pwm = Clear Up
Ddrb = 255
Pwm2a = 128


Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Waitms 50

Cls
Cursor Off
Do
  Do
  Loop Until Pinc.0 = 0
  Do
  Loop Until Pinc.0 = 1
  Timer1 = 0
  Do
  Loop Until Pinc.0 = 0
  Do
  Loop Until Pinc.0 = 1
  D = Timer1
  D = D / 2
  Locate 1 , 1
  Lcd "Timer1 ="
  Locate 2 , 1
  Lcd D
  Lcd " us    "
  Print "Timer1 = ";
  Print D;
  Print " us"
  Waitms 1000
Loop