'-------------------------------------
'UNO_I2C5.BAS Write to EEPROM 24C512
'-------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 64
$swstack = 32
$framesize = 64


Dim Adrs As Word
Dim H As Byte
Dim L As Byte
Dim Dat As Byte

Config Scl = Portc.5
Config Sda = Portc.4

I2cinit


'Open "COM1" For Binary As #1
'Echo Off

'Print "Write 24C512"

For Adrs = 0 To 65535
   'Input Dat                                                'start
   I2cstart
   I2cwbyte 160                                             'slave address 24C512
   H = High(adrs)
   L = Low(adrs)
   I2cwbyte H                                               'high address
   I2cwbyte L                                               'low address
   I2cwbyte 0                                               'Dat                                             'write byte
   I2cstop                                                  'stop
   Waitms 100

   Dat = 0

   I2cstart
I2cwbyte 160                                                'slave address 24C512
H = High(adrs)
L = Low(adrs)
I2cwbyte H                                                  'high address
I2cwbyte L                                                  'low address
I2cstop
I2cstart                                                    'repeated start
I2cwbyte 161                                                'slave address (read)
 I2crbyte Dat , Ack                                         'read byte
 I2cstop                                                    'generate stop
 Print Dat

Next Adrs
End