'-------------------------------------------------------------------------------
'UNO_RX1.BAS   B1 RF out, C2 RF in
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 16
$swstack = 16
$framesize = 16

Dim D As Word


Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off

Config Adc = Single , Prescaler = 64 , Reference = Avcc     '5 V

Config Timer1 = Pwm , Prescale = 1 , Pwm = 10 , Compare A Pwm = Clear Up
Tccr1a = &B10000010                                         'Phase-correct PWM, Top=ICR1
Tccr1b = &B00010001                                         'Prescaler=1

D = 8                                                       '1 MHz
Icr1 = D
Ocr1a = D / 2
Portc.2 = 1


Do
  D = Getadc(2)
  Print D
  Locate 1 , 1
  Lcd D
  Lcd "    "
  Waitms 500
Loop